import { MiscIndexedBlockchain } from "./MiscIndexedBlockchain";
import { IindexEntry, IndexEntry, MindexEntry, SindexEntry } from "../indexer";
import { BlockchainOperator } from "./interfaces/BlockchainOperator";
import { ConfDTO } from "../dto/ConfDTO";
import { BlockDTO } from "../dto/BlockDTO";
import { DBHead } from "../db/DBHead";
import { DBBlock } from "../db/DBBlock";
export declare class DuniterBlockchain extends MiscIndexedBlockchain {
    constructor(blockchainStorage: BlockchainOperator, dal: any);
    static checkBlock(block: BlockDTO, withPoWAndSignature: boolean, conf: ConfDTO, dal: any): Promise<{
        index: IndexEntry[];
        HEAD: DBHead;
    }>;
    pushTheBlock(obj: BlockDTO, index: IndexEntry[], HEAD: DBHead | null, conf: ConfDTO, dal: any, logger: any): Promise<BlockDTO>;
    saveBlockData(current: DBBlock, block: BlockDTO, conf: ConfDTO, dal: any, logger: any, index: IndexEntry[], HEAD: DBHead | null): Promise<DBBlock>;
    saveParametersForRoot(block: BlockDTO, conf: ConfDTO, dal: any): Promise<any>;
    createNewcomers(iindex: IindexEntry[], dal: any, logger: any): Promise<void>;
    updateMembers(block: BlockDTO, dal: any): Promise<void>;
    updateWallets(sindex: SindexEntry[], aDal: any, reverse?: boolean): Promise<void>;
    revertBlock(number: number, hash: string, dal: any): Promise<any>;
    undoMembersUpdate(blockstamp: string, dal: any): Promise<void>;
    undoDeleteTransactions(block: BlockDTO, dal: any): Promise<void>;
    /**
     * Delete certifications from the sandbox since it has been written.
     *
     * @param block Block in which are contained the certifications to remove from sandbox.
     * @param dal The DAL
     */
    removeCertificationsFromSandbox(block: BlockDTO, dal: any): Promise<void>;
    /**
     * Delete memberships from the sandbox since it has been written.
     *
     * @param block Block in which are contained the certifications to remove from sandbox.
     * @param dal The DAL
     */
    removeMembershipsFromSandbox(block: BlockDTO, dal: any): Promise<void>;
    computeToBeRevoked(mindex: MindexEntry[], dal: any): Promise<void>;
    deleteTransactions(block: BlockDTO, dal: any): Promise<void>;
    updateBlocksComputedVars(current: {
        unitbase: number;
        monetaryMass: number;
    } | null, block: {
        number: number;
        unitbase: number;
        dividend: number | null;
        membersCount: number;
        monetaryMass: number;
    }): void;
    static pushStatsForBlocks(blocks: BlockDTO[], dal: any): any;
    pushSideBlock(obj: BlockDTO, dal: any, logger: any): Promise<DBBlock>;
    revertHead(): Promise<void>;
}
