import { BasicBlockchain } from "./BasicBlockchain";
import { IndexOperator } from "./interfaces/IndexOperator";
import { BlockchainOperator } from "./interfaces/BlockchainOperator";
export declare class IndexedBlockchain extends BasicBlockchain {
    private indexOperations;
    private numberField;
    private pkFields;
    private initIndexer;
    constructor(bcOperations: BlockchainOperator, indexOperations: IndexOperator, numberField: string, pkFields: any);
    recordIndex(index: {
        [index: string]: any;
    }): Promise<void>;
    indexTrim(maxNumber: number): Promise<void>;
    indexCount(indexName: string, criterias: {
        [index: string]: any;
    }): Promise<number>;
    indexReduce(indexName: string, criterias: {
        [index: string]: any;
    }): Promise<any>;
    indexReduceGroupBy(indexName: string, criterias: {
        [index: string]: any;
    }, properties: string[]): Promise<any>;
    indexRevert(blockNumber: number): Promise<void>;
}
