"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeUTF8 = function (s) {
    let i, d = unescape(encodeURIComponent(s)), b = new Uint8Array(d.length);
    for (i = 0; i < d.length; i++)
        b[i] = d.charCodeAt(i);
    return b;
};
exports.encodeUTF8 = function (arr) {
    let i, s = [];
    for (i = 0; i < arr.length; i++)
        s.push(String.fromCharCode(arr[i]));
    return decodeURIComponent(escape(s.join('')));
};
exports.encodeBase64 = function (arr) {
    if (typeof btoa === 'undefined' || !window) {
        return (new Buffer(arr)).toString('base64');
    }
    else {
        let i, s = [], len = arr.length;
        for (i = 0; i < len; i++)
            s.push(String.fromCharCode(arr[i]));
        return btoa(s.join(''));
    }
};
exports.decodeBase64 = function (s) {
    if (typeof atob === 'undefined' || !window) {
        return new Uint8Array(Array.prototype.slice.call(new Buffer(s, 'base64'), 0));
    }
    else {
        let i, d = atob(s), b = new Uint8Array(d.length);
        for (i = 0; i < d.length; i++)
            b[i] = d.charCodeAt(i);
        return b;
    }
};
//# sourceMappingURL=nacl-util.js.map