"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const AbstractCFS_1 = require("./AbstractCFS");
const _ = require('underscore');
class StatDAL extends AbstractCFS_1.AbstractCFS {
    constructor(rootPath, qioFS) {
        super(rootPath, qioFS);
    }
    init() {
        return Promise.resolve();
    }
    loadStats() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                return yield this.coreFS.readJSON('stats.json');
            }
            catch (e) {
                return null;
            }
        });
    }
    getStat(statName) {
        return this.loadStats().then((stats) => (stats && stats[statName]) || { statName: statName, blocks: [], lastParsedBlock: -1 });
    }
    pushStats(statsToPush) {
        return __awaiter(this, void 0, void 0, function* () {
            const stats = (yield this.loadStats()) || {};
            _.keys(statsToPush).forEach(function (statName) {
                if (!stats[statName]) {
                    stats[statName] = { blocks: [] };
                }
                stats[statName].blocks = stats[statName].blocks.concat(statsToPush[statName].blocks);
            });
            return this.coreFS.writeJSON('stats.json', stats);
        });
    }
}
exports.StatDAL = StatDAL;
//# sourceMappingURL=StatDAL.js.map