import { SQLiteDriver } from "../drivers/SQLiteDriver";
import { AbstractSQLite } from "./AbstractSQLite";
export declare class DBPeer {
    version: number;
    currency: string;
    status: string;
    statusTS: number;
    hash: string;
    first_down: number | null;
    last_try: number | null;
    pubkey: string;
    block: string;
    signature: string;
    endpoints: string[];
    raw: string;
    json(): {
        version: number;
        currency: string;
        endpoints: string[];
        status: string;
        block: string;
        signature: string;
        raw: string;
        pubkey: string;
    };
}
export declare class PeerDAL extends AbstractSQLite<DBPeer> {
    constructor(driver: SQLiteDriver);
    init(): Promise<void>;
    listAll(): Promise<DBPeer[]>;
    getPeer(pubkey: string): Promise<DBPeer>;
    getPeersWithEndpointsLike(str: string): Promise<DBPeer[]>;
    savePeer(peer: DBPeer): Promise<void>;
    removePeerByPubkey(pubkey: string): Promise<void>;
    removeAll(): Promise<void>;
}
