"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
class SandBox {
    constructor(maxSize, findElements, compareElements) {
        this.findElements = findElements;
        this.compareElements = compareElements;
        this.maxSize = maxSize || 10;
    }
    acceptNewSandBoxEntry(element, pubkey) {
        return __awaiter(this, void 0, void 0, function* () {
            if (element.pubkey === pubkey) {
                return true;
            }
            const elements = yield this.findElements();
            if (elements.length < this.maxSize) {
                return true;
            }
            const lowestElement = elements[elements.length - 1];
            const comparison = this.compareElements(element, lowestElement);
            return comparison > 0;
        });
    }
    getSandboxRoom() {
        return __awaiter(this, void 0, void 0, function* () {
            const elems = yield this.findElements();
            return this.maxSize - elems.length;
        });
    }
}
exports.SandBox = SandBox;
//# sourceMappingURL=SandBox.js.map