import { SQLiteDriver } from "../drivers/SQLiteDriver";
import { AbstractSQLite } from "./AbstractSQLite";
export interface DBWallet {
    conditions: string;
    balance: number;
}
/**
 * Facility table saving the current state of a wallet.
 * @param driver SQL driver for making SQL requests.
 * @constructor
 */
export declare class WalletDAL extends AbstractSQLite<DBWallet> {
    constructor(driver: SQLiteDriver);
    init(): Promise<void>;
    getWallet(conditions: string): Promise<DBWallet>;
    saveWallet(wallet: DBWallet): Promise<void>;
}
