"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const AbstractSQLite_1 = require("./AbstractSQLite");
/**
 * Facility table saving the current state of a wallet.
 * @param driver SQL driver for making SQL requests.
 * @constructor
 */
class WalletDAL extends AbstractSQLite_1.AbstractSQLite {
    constructor(driver) {
        super(driver, 'wallet', 
        // PK fields
        ['conditions'], 
        // Fields
        [
            'conditions',
            'balance'
        ], 
        // Arrays
        [], 
        // Booleans
        [], 
        // BigIntegers
        ['monetaryMass'], 
        // Transient
        []);
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.exec('BEGIN;' +
                'CREATE TABLE IF NOT EXISTS ' + this.table + ' (' +
                'conditions TEXT NOT NULL,' +
                'balance INTEGER NOT NULL,' +
                'PRIMARY KEY (conditions)' +
                ');' +
                'CREATE INDEX IF NOT EXISTS wallet_balance ON wallet(balance);' +
                'COMMIT;');
        });
    }
    getWallet(conditions) {
        return this.sqlFindOne({ conditions });
    }
    saveWallet(wallet) {
        return this.saveEntity(wallet);
    }
}
exports.WalletDAL = WalletDAL;
//# sourceMappingURL=WalletDAL.js.map