import { AbstractIndex } from "../AbstractIndex";
import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { CindexEntry } from "../../../indexer";
export declare class CIndexDAL extends AbstractIndex<CindexEntry> {
    constructor(driver: SQLiteDriver);
    init(): Promise<void>;
    reducablesFrom(from: string): Promise<any>;
    trimExpiredCerts(belowNumber: number): Promise<void>;
    getWrittenOn(blockstamp: string): Promise<CindexEntry[]>;
    findExpired(medianTime: number): Promise<CindexEntry[]>;
    getValidLinksTo(receiver: string): Promise<CindexEntry[]>;
    getValidLinksFrom(issuer: string): Promise<CindexEntry[]>;
    existsNonReplayableLink(issuer: string, receiver: string): Promise<boolean>;
    removeBlock(blockstamp: string): Promise<void>;
}
