import { SQLiteDriver } from "../../drivers/SQLiteDriver";
import { AbstractIndex } from "../AbstractIndex";
import { IindexEntry } from "../../../indexer";
export interface OldIindexEntry extends IindexEntry {
    pubkey: string;
    buid: string | null;
    revocation_sig: string | null;
}
export declare class IIndexDAL extends AbstractIndex<IindexEntry> {
    constructor(driver: SQLiteDriver);
    init(): Promise<void>;
    getMembers(): Promise<any>;
    getMembersPubkeys(): Promise<IindexEntry[]>;
    getToBeKickedPubkeys(): Promise<any>;
    searchThoseMatching(search: string): Promise<OldIindexEntry[]>;
    getFromPubkey(pubkey: string): Promise<OldIindexEntry | null>;
    getFromUID(uid: string): Promise<OldIindexEntry | null>;
    getFromHash(hash: string): Promise<OldIindexEntry | null>;
    reducable(pub: string): Promise<IindexEntry[]>;
    removeBlock(blockstamp: string): Promise<void>;
    private entityOrNull(field, value, retrieveOnField?);
    private toCorrectEntity(row);
}
