"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const TransactionDTO_1 = require("../dto/TransactionDTO");
class DBTransaction extends TransactionDTO_1.TransactionDTO {
    constructor(version, currency, locktime, hash, blockstamp, issuers, inputs, outputs, unlocks, signatures, comment, blockstampTime, written, removed, block_number, time) {
        super(version, currency, locktime, hash, blockstamp, blockstampTime, issuers, inputs, outputs, unlocks, signatures, comment);
        this.version = version;
        this.currency = currency;
        this.locktime = locktime;
        this.hash = hash;
        this.blockstamp = blockstamp;
        this.issuers = issuers;
        this.inputs = inputs;
        this.outputs = outputs;
        this.unlocks = unlocks;
        this.signatures = signatures;
        this.comment = comment;
        this.blockstampTime = blockstampTime;
        this.written = written;
        this.removed = removed;
        this.block_number = block_number;
        this.time = time;
    }
    static fromTransactionDTO(dto, blockstampTime, written, removed, block_number, block_medianTime) {
        return new DBTransaction(dto.version, dto.currency, dto.locktime, dto.hash, dto.blockstamp, dto.issuers, dto.inputs, dto.outputs, dto.unlocks, dto.signatures, dto.comment || "", blockstampTime, written, removed, block_number, block_medianTime);
    }
}
exports.DBTransaction = DBTransaction;
//# sourceMappingURL=DBTransaction.js.map