"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("../common-libs/constants");
const _ = require('underscore');
const constants = require('../constants');
class ConfDTO {
    constructor(loglevel, currency, endpoints, rmEndpoints, rootoffset, upInterval, cpu, nbCores, prefix, powSecurityRetryDelay, powMaxHandicap, c, dt, dtReeval, dtDiffEval, ud0, udTime0, udReevalTime0, stepMax, sigPeriod, msPeriod, sigValidity, msValidity, sigQty, sigStock, xpercent, percentRot, powDelay, avgGenTime, medianTimeBlocks, httplogs, timeout, isolate, forksize, idtyWindow, msWindow, sigWindow, switchOnHeadAdvance, pair, oldPair, salt, passwd, remoteport, remotehost, remoteipv4, remoteipv6, port, ipv4, ipv6, dos, upnp, homename, memory, nobma, bmaWithCrawler, proxiesConf, ws2p) {
        this.loglevel = loglevel;
        this.currency = currency;
        this.endpoints = endpoints;
        this.rmEndpoints = rmEndpoints;
        this.rootoffset = rootoffset;
        this.upInterval = upInterval;
        this.cpu = cpu;
        this.nbCores = nbCores;
        this.prefix = prefix;
        this.powSecurityRetryDelay = powSecurityRetryDelay;
        this.powMaxHandicap = powMaxHandicap;
        this.c = c;
        this.dt = dt;
        this.dtReeval = dtReeval;
        this.dtDiffEval = dtDiffEval;
        this.ud0 = ud0;
        this.udTime0 = udTime0;
        this.udReevalTime0 = udReevalTime0;
        this.stepMax = stepMax;
        this.sigPeriod = sigPeriod;
        this.msPeriod = msPeriod;
        this.sigValidity = sigValidity;
        this.msValidity = msValidity;
        this.sigQty = sigQty;
        this.sigStock = sigStock;
        this.xpercent = xpercent;
        this.percentRot = percentRot;
        this.powDelay = powDelay;
        this.avgGenTime = avgGenTime;
        this.medianTimeBlocks = medianTimeBlocks;
        this.httplogs = httplogs;
        this.timeout = timeout;
        this.isolate = isolate;
        this.forksize = forksize;
        this.idtyWindow = idtyWindow;
        this.msWindow = msWindow;
        this.sigWindow = sigWindow;
        this.switchOnHeadAdvance = switchOnHeadAdvance;
        this.pair = pair;
        this.oldPair = oldPair;
        this.salt = salt;
        this.passwd = passwd;
        this.remoteport = remoteport;
        this.remotehost = remotehost;
        this.remoteipv4 = remoteipv4;
        this.remoteipv6 = remoteipv6;
        this.port = port;
        this.ipv4 = ipv4;
        this.ipv6 = ipv6;
        this.dos = dos;
        this.upnp = upnp;
        this.homename = homename;
        this.memory = memory;
        this.nobma = nobma;
        this.bmaWithCrawler = bmaWithCrawler;
        this.proxiesConf = proxiesConf;
        this.ws2p = ws2p;
    }
    static mock() {
        return new ConfDTO("", "", [], [], 0, 0, 0.6, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, false, 0, false, 0, 0, 0, 0, 0, { pub: '', sec: '' }, null, "", "", 0, "", "", "", 0, "", "", null, false, "", true, false, true, undefined);
    }
    static defaultConf() {
        return {
            "currency": null,
            "endpoints": [],
            "rmEndpoints": [],
            "upInterval": 3600 * 1000,
            "c": constants.CONTRACT.DEFAULT.C,
            "dt": constants.CONTRACT.DEFAULT.DT,
            "dtReeval": constants.CONTRACT.DEFAULT.DT_REEVAL,
            "ud0": constants.CONTRACT.DEFAULT.UD0,
            "stepMax": constants.CONTRACT.DEFAULT.STEPMAX,
            "sigPeriod": constants.CONTRACT.DEFAULT.SIGPERIOD,
            "sigValidity": constants.CONTRACT.DEFAULT.SIGVALIDITY,
            "msValidity": constants.CONTRACT.DEFAULT.MSVALIDITY,
            "sigQty": constants.CONTRACT.DEFAULT.SIGQTY,
            "xpercent": constants.CONTRACT.DEFAULT.X_PERCENT,
            "percentRot": constants.CONTRACT.DEFAULT.PERCENTROT,
            "powDelay": constants.CONTRACT.DEFAULT.POWDELAY,
            "avgGenTime": constants.CONTRACT.DEFAULT.AVGGENTIME,
            "dtDiffEval": constants.CONTRACT.DEFAULT.DTDIFFEVAL,
            "medianTimeBlocks": constants.CONTRACT.DEFAULT.MEDIANTIMEBLOCKS,
            "httplogs": false,
            "udid2": false,
            "timeout": 3000,
            "isolate": false,
            "forksize": constants.BRANCHES.DEFAULT_WINDOW_SIZE,
            "switchOnHeadAdvance": constants_1.CommonConstants.SWITCH_ON_BRANCH_AHEAD_BY_X_BLOCKS
        };
    }
    static complete(conf) {
        return _(ConfDTO.defaultConf()).extend(conf);
    }
}
exports.ConfDTO = ConfDTO;
//# sourceMappingURL=ConfDTO.js.map