import { RevocationDTO } from "./RevocationDTO";
import { DBIdentity } from "../dal/sqliteDAL/IdentityDAL";
export interface HashableIdentity {
    buid: string;
    uid: string;
    pubkey: string;
}
export interface BasicIdentity {
    buid: string;
    uid: string;
    pubkey: string;
    sig: string;
}
export declare class IdentityDTO {
    version: number;
    currency: string;
    pubkey: string;
    sig: string;
    buid: string;
    uid: string;
    constructor(version: number, currency: string, pubkey: string, sig: string, buid: string, uid: string);
    readonly hash: string;
    private getTargetHash();
    inline(): string;
    rawWithoutSig(): string;
    getRawSigned(): string;
    static fromInline(inline: string, currency?: string): IdentityDTO;
    static getTargetHash(idty: HashableIdentity): string;
    static fromJSONObject(obj: any): IdentityDTO;
    static fromBasicIdentity(basic: BasicIdentity): DBIdentity;
    static fromRevocation(revoc: RevocationDTO): DBIdentity;
    getHash(): string;
}
