import { DBPeer } from "../dal/sqliteDAL/PeerDAL";
import { Cloneable } from "./Cloneable";
export interface WS2PEndpoint {
    uuid: string;
    host: string;
    port: number;
}
export declare class PeerDTO implements Cloneable {
    version: number;
    currency: string;
    pubkey: string;
    blockstamp: string;
    endpoints: string[];
    signature: string;
    status: string;
    statusTS: number;
    clone(): any;
    member: boolean;
    constructor(version: number, currency: string, pubkey: string, blockstamp: string, endpoints: string[], signature: string, status: string, statusTS: number, member?: boolean);
    readonly block: string;
    blockNumber(): number;
    keyID(): string;
    getRawUnsigned(): string;
    getRaw(): string;
    getRawSigned(): string;
    json(): {
        version: number;
        currency: string;
        endpoints: string[];
        status: string;
        block: string;
        signature: string;
        raw: string;
        pubkey: string;
    };
    getBMA(): any;
    getWS2P(canReachTorEp: boolean, canReachClearEp: boolean): {
        uuid: any;
        host: any;
        port: number;
        path: any;
    } | null;
    getDns(): any;
    getIPv4(): any;
    getIPv6(): any;
    getPort(): any;
    getHostPreferDNS(): any;
    getURL(): any;
    hasValid4(bma: any): boolean;
    getNamedURL(): any;
    isReachable(): boolean;
    containsEndpoint(ep: string): boolean;
    containsAllEndpoints(endpoints: string[]): boolean;
    endpointSum(): string;
    getHash(): string;
    toDBPeer(): DBPeer;
    static blockNumber(blockstamp: string): number;
    static fromDBPeer(p: DBPeer): PeerDTO;
    static fromJSONObject(obj: any): PeerDTO;
    static endpoint2host(endpoint: string): any;
    static indexOfFirst(endpoints: string[], intoEndpoints: string[]): number;
}
