"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("./common-libs/constants");
const SocksProxyAgent = require('socks-proxy-agent');
class ProxiesConf {
    constructor() {
        this.proxySocksAddress = undefined;
        this.proxyTorAddress = undefined;
        this.reachingClearEp = 'clear';
        this.forceTor = false;
    }
    static canReachClearEndpoint(proxiesConf) {
        return (proxiesConf === undefined || proxiesConf.reachingClearEp !== 'none');
    }
    static canReachTorEndpoint(proxiesConf) {
        return (proxiesConf !== undefined && (proxiesConf.forceTor || proxiesConf.proxyTorAddress !== undefined));
    }
    static httpProxy(url, proxiesConf) {
        return ProxiesConf.chooseProxyAgent(url, proxiesConf, constants_1.CommonConstants.HOST_ONION_REGEX);
    }
    static wsProxy(address, proxiesConf) {
        return ProxiesConf.chooseProxyAgent(address, proxiesConf, constants_1.CommonConstants.WS_FULL_ADDRESS_ONION_REGEX);
    }
    static chooseProxyAgent(address, proxiesConf, onionRegex) {
        if (proxiesConf !== undefined) {
            if (address.match(onionRegex)) {
                if (ProxiesConf.canReachTorEndpoint(proxiesConf)) {
                    return proxiesConf.proxyTorAddress;
                }
            }
            else {
                if (ProxiesConf.canReachClearEndpoint(proxiesConf)) {
                    if (proxiesConf.reachingClearEp == 'tor') {
                        return proxiesConf.proxyTorAddress;
                    }
                    else {
                        return proxiesConf.proxySocksAddress;
                    }
                }
            }
        }
        return undefined;
    }
}
exports.ProxiesConf = ProxiesConf;
//# sourceMappingURL=proxy.js.map