import { ConfDTO } from "../dto/ConfDTO";
import { FileDAL } from "../dal/fileDAL";
import { DBBlock } from "../db/DBBlock";
import { TransactionDTO, TxSignatureResult } from "../dto/TransactionDTO";
import { BlockDTO } from "../dto/BlockDTO";
export interface ParamEval {
    successful: boolean;
    funcName: string;
    parameter: string;
}
export declare function evalParams(params: string[], conditions: string | undefined, sigResult: TxSignatureResult): ParamEval[];
export declare const GLOBAL_RULES_FUNCTIONS: {
    checkIdentitiesAreWritable: (block: {
        identities: string[];
        version: number;
    }, conf: ConfDTO, dal: FileDAL) => Promise<boolean>;
    checkSourcesAvailability: (block: {
        transactions: TransactionDTO[];
        medianTime: number;
    }, conf: ConfDTO, dal: FileDAL, alsoCheckPendingTransactions: boolean) => Promise<boolean>;
};
export declare const GLOBAL_RULES_HELPERS: {
    checkMembershipBlock: (ms: any, current: DBBlock, conf: ConfDTO, dal: FileDAL) => Promise<any>;
    checkCertificationIsValid: (cert: any, current: BlockDTO, findIdtyFunc: any, conf: ConfDTO, dal: FileDAL) => Promise<boolean>;
    checkCertificationIsValidForBlock: (cert: any, block: {
        number: number;
        currency: string;
    }, findIdtyFunc: (b: {
        number: number;
        currency: string;
    }, pubkey: string, dal: FileDAL) => Promise<any>, conf: ConfDTO, dal: FileDAL) => Promise<boolean>;
    isOver3Hops: (member: any, newLinks: any, newcomers: string[], current: DBBlock, conf: ConfDTO, dal: FileDAL) => Promise<boolean>;
    checkExistsUserID: (uid: string, dal: FileDAL) => any;
    checkExistsPubkey: (pub: string, dal: FileDAL) => any;
    checkSingleTransaction: (tx: TransactionDTO, block: {
        medianTime: number;
    }, conf: ConfDTO, dal: FileDAL, alsoCheckPendingTransactions?: boolean) => Promise<boolean>;
    checkTxBlockStamp: (tx: TransactionDTO, dal: FileDAL) => Promise<void>;
};
export declare function setLogger(newLogger: any): void;
