/// <reference types="node" />
import { NetworkConfDTO } from "../../lib/dto/ConfDTO";
import { Server } from "../../../server";
import * as stream from "stream";
export declare const BmaDependency: {
    duniter: {
        cliOptions: ({
            value: string;
            desc: string;
        } | {
            value: string;
            desc: string;
            parser: (val: string) => number;
        })[];
        wizard: {
            'network': (conf: NetworkConfDTO, program: any, logger: any) => Promise<void>;
            'network-reconfigure': (conf: NetworkConfDTO, program: any, logger: any) => Promise<void>;
        };
        config: {
            onLoading: (conf: NetworkConfDTO, program: any, logger: any) => Promise<void>;
            beforeSave: (conf: NetworkConfDTO, program: any) => Promise<void>;
        };
        service: {
            input: (server: Server, conf: NetworkConfDTO, logger: any) => BMAPI;
        };
        methods: {
            noLimit: () => void;
            bma: any;
            dtos: any;
            getMainEndpoint: (conf: NetworkConfDTO) => Promise<string>;
        };
    };
};
export declare class BMAPI extends stream.Transform {
    private server;
    private conf;
    private logger;
    private bmapi;
    private upnpAPI;
    constructor(server: Server, conf: NetworkConfDTO, logger: any);
    startService: () => Promise<void>;
    stopService: () => Promise<void>;
}
