"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const AbstractController_1 = require("./AbstractController");
class NodeBinding extends AbstractController_1.AbstractController {
    constructor() {
        super(...arguments);
        this.summary = () => {
            return {
                "duniter": {
                    "software": "duniter",
                    "version": this.server.version,
                    "forkWindowSize": this.server.conf.forksize
                }
            };
        };
    }
    sandboxes() {
        return __awaiter(this, void 0, void 0, function* () {
            return {
                identities: yield sandboxIt(this.server.dal.idtyDAL.sandbox),
                memberships: yield sandboxIt(this.server.dal.msDAL.sandbox),
                transactions: yield sandboxIt(this.server.dal.txsDAL.sandbox)
            };
        });
    }
}
exports.NodeBinding = NodeBinding;
function sandboxIt(sandbox) {
    return __awaiter(this, void 0, void 0, function* () {
        return {
            size: sandbox.maxSize,
            free: yield sandbox.getSandboxRoom()
        };
    });
}
//# sourceMappingURL=node.js.map