import { NetworkConfDTO } from "../../../lib/dto/ConfDTO";
import { Server } from "../../../../server";
export interface NetworkInterface {
    ip: string | null;
    port: number | null;
}
export declare const Network: {
    getBestLocalIPv4: () => any;
    getBestLocalIPv6: () => any;
    listInterfaces: () => {
        name: any;
        addresses: any;
    }[];
    upnpConf: (noupnp: boolean, logger: any) => Promise<NetworkConfDTO>;
    getRandomPort: (conf: NetworkConfDTO) => number;
    createServersAndListen: (name: string, server: Server, interfaces: NetworkInterface[], httpLogs: boolean, logger: any, staticPath: string | null, routingCallback: any, listenWebSocket: any, enableFileUpload?: boolean) => Promise<BmaApi>;
};
export declare class BmaApi {
    private name;
    private interfaces;
    private ddosInstance;
    private httpServers;
    private logger;
    private listenings;
    constructor(name: string, interfaces: any, ddosInstance: any, httpServers: any, logger: any);
    getDDOS(): any;
    closeConnections(): Promise<never[]>;
    openConnections(): Promise<never[]>;
}
