import { ConfDTO } from "../../lib/dto/ConfDTO";
import { Server } from "../../../server";
import { Contacter } from "./lib/contacter";
import { Crawler } from "./lib/crawler";
import { Synchroniser } from "./lib/sync";
export declare const CrawlerDependency: {
    duniter: {
        service: {
            process: (server: Server, conf: ConfDTO, logger: any) => Crawler;
        };
        methods: {
            contacter: (host: string, port: number, opts: any) => Contacter;
            pullBlocks: (server: Server, pubkey: string) => Promise<void>;
            pullSandbox: (server: Server) => Promise<void>;
            synchronize: (server: Server, onHost: string, onPort: number, upTo: number, chunkLength: number) => {
                flow: Synchroniser;
                syncPromise: Promise<void>;
            };
            testForSync: (server: Server, onHost: string, onPort: number) => Promise<any>;
        };
        cliOptions: {
            value: string;
            desc: string;
        }[];
        cli: ({
            name: string;
            desc: string;
            preventIfRunning: boolean;
            onDatabaseExecute: (server: Server, conf: ConfDTO, program: any, params: any) => Promise<void>;
        } | {
            name: string;
            desc: string;
            onDatabaseExecute: (server: Server, conf: ConfDTO, program: any, params: any) => Promise<void>;
        })[];
    };
};
