/// <reference types="node" />
import * as stream from "stream";
import { Server } from "../../../../server";
import { FileDAL } from "../../../lib/dal/fileDAL";
import { BlockchainService } from "../../../service/BlockchainService";
import { ConfDTO } from "../../../lib/dto/ConfDTO";
import { PeeringService } from "../../../service/PeeringService";
export declare class Synchroniser extends stream.Duplex {
    private server;
    private host;
    private port;
    private slowOption;
    private watcher;
    private speed;
    private blocksApplied;
    private contacterOptions;
    constructor(server: Server, host: string, port: number, interactive?: boolean, slowOption?: boolean);
    readonly conf: ConfDTO;
    readonly logger: any;
    readonly PeeringService: PeeringService;
    readonly BlockchainService: BlockchainService;
    readonly dal: FileDAL;
    _read(): void;
    _write(): void;
    private logRemaining(to);
    test(): Promise<any>;
    sync(to: number, chunkLen: number, askedCautious?: boolean, nopeers?: boolean, noShufflePeers?: boolean): Promise<void>;
    syncPeers(nopeers: boolean, fullSync: boolean, host: string, port: number, to?: number): Promise<void>;
    private syncPeer(node);
}
