import { ConfDTO } from "../../../lib/dto/ConfDTO";
import { Server } from "../../../../server";
import { BlockchainContext } from "../../../lib/computation/BlockchainContext";
import { DBBlock } from "../../../lib/db/DBBlock";
import { BlockDTO } from "../../../lib/dto/BlockDTO";
export declare class BlockGenerator {
    private server;
    conf: ConfDTO;
    dal: any;
    mainContext: BlockchainContext;
    selfPubkey: string;
    logger: any;
    constructor(server: Server);
    nextBlock(manualValues?: any, simulationValues?: any): Promise<BlockDTO>;
    manualRoot(): Promise<BlockDTO>;
    /**
     * Generate next block, gathering both updates & newcomers
     */
    private generateNextBlock(generator, manualValues?, simulationValues?);
    private findNewcomersAndLeavers(current, filteringFunc);
    private findTransactions(current);
    private findLeavers(current);
    private findNewcomers(current, filteringFunc);
    private checkWoTConstraints(block, newLinks, current);
    private iteratedChecking(newcomers, checkWoTForNewcomers);
    private getPreJoinData(current);
    private computeNewLinks(forBlock, theNewcomers, joinData, updates);
    newCertsToLinks(newCerts: any, updates: any): any;
    computeNewCerts(forBlock: number, theNewcomers: any, joinData: any): Promise<any>;
    getSinglePreJoinData(current: DBBlock, idHash: string, joiners: string[]): Promise<{
        identity: any;
        key: null;
        idHash: string;
        certs: any;
    }>;
    private createBlock(current, joinData, leaveData, updates, revocations, exclusions, wereExcluded, transactions, manualValues);
}
export declare class BlockGeneratorWhichProves extends BlockGenerator {
    private prover;
    constructor(server: Server, prover: any);
    makeNextBlock(block: DBBlock | null, trial: number, manualValues?: any): Promise<any>;
}
