import { Server } from "../../../../server";
import { BlockDTO } from "../../../lib/dto/BlockDTO";
import { ConfDTO, Keypair } from "../../../lib/dto/ConfDTO";
export declare class WorkerFarm {
    private server;
    private logger;
    private theEngine;
    private onAlmostPoW;
    private powPromise;
    private stopPromise;
    private checkPoWandNotify;
    constructor(server: Server, logger: any);
    changeCPU(cpu: any): Promise<any>;
    changePoWPrefix(prefix: any): Promise<any>;
    isComputing(): boolean;
    isStopping(): boolean;
    /**
     * Eventually stops the engine PoW if one was computing
     */
    stopPoW(): any;
    shutDownEngine(): void;
    /**
     * Starts a new computation of PoW
     * @param stuff The necessary data for computing the PoW
     */
    askNewProof(stuff: any): Promise<any>;
    setOnAlmostPoW(onPoW: any): void;
}
export declare class BlockProver {
    private server;
    logger: any;
    waitResolve: any;
    workerFarmPromise: any;
    constructor(server: Server);
    readonly conf: ConfDTO;
    readonly pair: Keypair | null;
    getWorker(): Promise<WorkerFarm>;
    cancel(): Promise<void>;
    prove(block: any, difficulty: any, forcedTime?: any): Promise<BlockDTO>;
    changeCPU(cpu: number): Promise<any>;
    changePoWPrefix(prefix: any): Promise<any>;
    private powEvent(found, hash);
}
