import { ConfDTO } from "../../../lib/dto/ConfDTO";
/**
 * Cluster controller, handles the messages between the main program and the PoW cluster.
 */
export declare class Master {
    private nbCores;
    clusterId: number;
    currentPromise: any | null;
    slaves: any[];
    slavesMap: any;
    conf: any;
    logger: any;
    onInfoCallback: any;
    workersOnline: Promise<any>[];
    constructor(nbCores: number, logger: any);
    readonly nbWorkers: number;
    readonly hasProofPending: boolean;
    onInfoMessage: any;
    onWorkerMessage(worker: any, message: any): void;
    initCluster(): Promise<any[]>;
    changeConf(conf: ConfDTO): Promise<any>;
    cancelWork(): Promise<void>;
    newPromise(uuid: string): any;
    shutDownWorkers(): Promise<void>;
    proveByWorkers(stuff: any): Promise<any>;
    static defaultLogger(): {
        info: (message: any) => void;
    };
}
