"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const WS2PRequester_1 = require("./WS2PRequester");
const sandbox_1 = require("../../crawler/lib/sandbox");
class WS2PDocpoolPuller {
    constructor(server, connection) {
        this.server = server;
        this.connection = connection;
    }
    pull() {
        return __awaiter(this, void 0, void 0, function* () {
            const requester = WS2PRequester_1.WS2PRequester.fromConnection(this.connection);
            // node.pubkey = p.pubkey;
            return sandbox_1.pullSandboxToLocalServer(this.server.conf.currency, {
                getRequirementsPending: (minCert = 1) => {
                    return requester.getRequirementsPending(minCert);
                }
            }, this.server, this.server.logger);
        });
    }
}
exports.WS2PDocpoolPuller = WS2PDocpoolPuller;
//# sourceMappingURL=WS2PDocpoolPuller.js.map