import { WS2PConnection } from "./WS2PConnection";
import { BlockDTO } from "../../../lib/dto/BlockDTO";
export declare enum WS2P_REQ {
    WOT_REQUIREMENTS_OF_PENDING = 0,
    BLOCKS_CHUNK = 1,
    BLOCK_BY_NUMBER = 2,
    CURRENT = 3,
}
export declare class WS2PRequester {
    protected ws2pc: WS2PConnection;
    private constructor();
    static fromConnection(ws2pc: WS2PConnection): WS2PRequester;
    getCurrent(): Promise<BlockDTO>;
    getBlock(number: number): Promise<BlockDTO>;
    getBlocks(count: number, fromNumber: number): Promise<BlockDTO[]>;
    getPubkey(): string;
    getRequirementsPending(minCert?: number): Promise<any>;
    private query(req, params?);
}
