"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
var WS2P_REQ;
(function (WS2P_REQ) {
    WS2P_REQ[WS2P_REQ["WOT_REQUIREMENTS_OF_PENDING"] = 0] = "WOT_REQUIREMENTS_OF_PENDING";
    WS2P_REQ[WS2P_REQ["BLOCKS_CHUNK"] = 1] = "BLOCKS_CHUNK";
    WS2P_REQ[WS2P_REQ["BLOCK_BY_NUMBER"] = 2] = "BLOCK_BY_NUMBER";
    WS2P_REQ[WS2P_REQ["CURRENT"] = 3] = "CURRENT";
})(WS2P_REQ = exports.WS2P_REQ || (exports.WS2P_REQ = {}));
class WS2PRequester {
    constructor(ws2pc) {
        this.ws2pc = ws2pc;
    }
    static fromConnection(ws2pc) {
        return new WS2PRequester(ws2pc);
    }
    getCurrent() {
        return this.query(WS2P_REQ.CURRENT);
    }
    getBlock(number) {
        return this.query(WS2P_REQ.BLOCK_BY_NUMBER, { number });
    }
    getBlocks(count, fromNumber) {
        return this.query(WS2P_REQ.BLOCKS_CHUNK, { count, fromNumber });
    }
    getPubkey() {
        return this.ws2pc.pubkey || "########";
    }
    getRequirementsPending(minCert = 1) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.query(WS2P_REQ.WOT_REQUIREMENTS_OF_PENDING, { minCert });
        });
    }
    query(req, params = {}) {
        return this.ws2pc.request({
            name: WS2P_REQ[req],
            params: params
        });
    }
}
exports.WS2PRequester = WS2PRequester;
//# sourceMappingURL=WS2PRequester.js.map