/// <reference types="node" />
import { Server } from "../../../../server";
import { WS2PConnection } from "./WS2PConnection";
import { GlobalFifoPromise } from "../../../service/GlobalFifoPromise";
import * as events from "events";
import { WS2PMessageHandler } from "./impl/WS2PMessageHandler";
export declare class WS2PServer extends events.EventEmitter {
    private server;
    private host;
    private port;
    private fifo;
    private shouldAcceptConnection;
    private wss;
    private connections;
    private maxLevel2Size;
    private constructor();
    maxLevel2Peers: number;
    getConnexions(): WS2PConnection[];
    private listenToWebSocketConnections(messageHandler);
    trimConnections(): Promise<void>;
    private removeConnection(c);
    close(): Promise<{}>;
    getConnection(pubkeyOfConnection: string): Promise<WS2PConnection>;
    static bindOn(server: Server, host: string, port: number, fifo: GlobalFifoPromise, shouldAcceptConnection: (pubkey: string, connectedPubkeys: string[]) => Promise<boolean>, messageHandler: WS2PMessageHandler): Promise<WS2PServer>;
}
