"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const stream = require("stream");
const logger_1 = require("../../../lib/logger");
const logger = logger_1.NewLogger();
class WS2PStreamer extends stream.Transform {
    constructor(ws2pc) {
        super({ objectMode: true });
        this.ws2pc = ws2pc;
    }
    _write(obj, enc, done) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (obj.joiners) {
                    yield this.ws2pc.pushBlock(obj);
                }
                else if (obj.pubkey && obj.uid) {
                    yield this.ws2pc.pushIdentity(obj);
                }
                else if (obj.idty_uid) {
                    yield this.ws2pc.pushCertification(obj);
                }
                else if (obj.userid) {
                    yield this.ws2pc.pushMembership(obj);
                }
                else if (obj.issuers) {
                    yield this.ws2pc.pushTransaction(obj);
                }
                else if (obj.endpoints) {
                    yield this.ws2pc.pushPeer(obj);
                }
            }
            catch (e) {
                logger.warn('WS2P >> Streamer >>', e);
                this.ws2pc.close();
            }
            done && done();
        });
    }
}
exports.WS2PStreamer = WS2PStreamer;
//# sourceMappingURL=WS2PStreamer.js.map