"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const constants_1 = require("../../../lib/common-libs/constants");
exports.WS2PConstants = {
    WS2P_UPNP_TTL: 600,
    WS2P_PORTS_START: 20900,
    WS2P_PORTS_END: 20999,
    WS2P_UPNP_INTERVAL: 300,
    CONNEXION_TIMEOUT: 15000,
    REQUEST_TIMEOUT: 15000,
    CONNEXION_TOR_TIMEOUT: 30000,
    REQUEST_TOR_TIMEOUT: 60000,
    RECONNEXION_INTERVAL_IN_SEC: 60 * 10,
    BLOCK_PULLING_INTERVAL: 300 * 2,
    DOCPOOL_PULLING_INTERVAL: 3600 * 4,
    SANDBOX_FIRST_PULL_DELAY: 300 * 2,
    MAX_LEVEL_1_PEERS: 10,
    MAX_LEVEL_2_PEERS: 10,
    CONNECTIONS_LOW_LEVEL: 3,
    BAN_DURATION_IN_SECONDS: 120,
    BAN_ON_REPEAT_THRESHOLD: 5,
    ERROR_RECALL_DURATION_IN_SECONDS: 60,
    SINGLE_RECORD_PROTECTION_IN_SECONDS: 60,
    HEAD_V0_REGEXP: new RegExp('^WS2P:HEAD:'
        + constants_1.CommonConstants.FORMATS.PUBKEY + ':'
        + constants_1.CommonConstants.FORMATS.BLOCKSTAMP
        + '$'),
    HEAD_V1_REGEXP: new RegExp('^WS2P(?:O[CT][SAM])?(?:I[CT])?:HEAD:1:'
        + '(' + constants_1.CommonConstants.FORMATS.PUBKEY + '):'
        + '(' + constants_1.CommonConstants.FORMATS.BLOCKSTAMP + '):'
        + '(' + constants_1.CommonConstants.FORMATS.WS2PID + '):'
        + '(' + constants_1.CommonConstants.FORMATS.SOFTWARE + '):'
        + '(' + constants_1.CommonConstants.FORMATS.SOFT_VERSION + '):'
        + '(' + constants_1.CommonConstants.FORMATS.POW_PREFIX + ')'
        + '$'),
    HOST_ONION_REGEX: constants_1.CommonConstants.HOST_ONION_REGEX,
    FULL_ADDRESS_ONION_REGEX: constants_1.CommonConstants.WS_FULL_ADDRESS_ONION_REGEX,
    HEADS_SPREAD_TIMEOUT: 100 // Wait 100ms before sending a bunch of signed heads
};
//# sourceMappingURL=constants.js.map