export interface UPnPBinding {
    remotehost: string;
    host: string;
    port: number;
}
export declare class WS2PUpnp {
    private logger;
    private currentConfig;
    private interval;
    private client;
    constructor(logger: any);
    checkUPnPisAvailable(): Promise<boolean>;
    getCurrentConfig(): UPnPBinding | null;
    /**
     * Always open the same port during an execution of Duniter.
     * @returns { host:string, port:number }
     */
    openPort(): Promise<{
        host: string;
        port: number;
    }>;
    startRegular(): Promise<{
        host: string;
        port: number;
        available: boolean;
    }>;
    stopRegular(): void;
    static getLocalIP(client: any): Promise<string>;
    static getRemoteIP(client: any): Promise<string>;
    static getAvailablePort(client: any): Promise<{
        remotehost: string;
        host: string;
        port: number;
    }>;
    static getUPnPMappings(client: any): Promise<any>;
}
