"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ArrayBlockchain {
    constructor() {
        // The blockchain storage
        this.bcArray = [];
    }
    store(b) {
        this.bcArray.push(b);
        return Promise.resolve(b);
    }
    read(i) {
        return Promise.resolve(this.bcArray[i]);
    }
    head(n) {
        const index = Math.max(0, this.bcArray.length - 1 - (n || 0));
        return Promise.resolve(this.bcArray[index]);
    }
    height() {
        return Promise.resolve(this.bcArray.length);
    }
    headRange(m) {
        const index = Math.max(0, this.bcArray.length - (m || 0));
        return Promise.resolve(this.bcArray.slice(index, this.bcArray.length).reverse());
    }
    revertHead() {
        const reverted = this.bcArray.pop();
        return Promise.resolve(reverted);
    }
}
exports.ArrayBlockchain = ArrayBlockchain;
//# sourceMappingURL=ArrayBlockchain.js.map