"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const stream = require("stream");
const assert = require("assert");
const WS2PSingleWriteStream_1 = require("../../../../app/modules/ws2p/lib/WS2PSingleWriteStream");
const es = require('event-stream');
describe('WS2P Single Write limiter', () => {
    const PROTECTION_DURATION = 100;
    it('should detect double writings', () => __awaiter(this, void 0, void 0, function* () {
        const source = new Readable();
        const protection = new WS2PSingleWriteStream_1.WS2PSingleWriteStream(PROTECTION_DURATION);
        let nbDocs = 0;
        yield new Promise(res => {
            source
                .pipe(protection)
                .pipe(es.mapSync(() => {
                nbDocs++;
                if (nbDocs >= 2) {
                    res();
                }
            }));
            // Writing
            source.push({ joiners: [] }); // A block
            source.push({ joiners: [] }); // A block
            source.push({ endpoints: [] }); // A peer
        });
        assert.equal(nbDocs, 2);
        assert.equal(protection.getNbProtectionsCurrently(), 2);
        yield new Promise(res => setTimeout(res, PROTECTION_DURATION + 100));
        assert.equal(protection.getNbProtectionsCurrently(), 0);
    }));
});
class Readable extends stream.Readable {
    constructor() {
        super({ objectMode: true });
    }
    _read() {
        return __awaiter(this, void 0, void 0, function* () {
        });
    }
}
//# sourceMappingURL=single_write.js.map