"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const toolbox_1 = require("./tools/toolbox");
const should = require('should');
const querablep = require('querablep');
describe("Server shutdown", () => {
    it('should not interrupt a task in the documents FIFO', () => __awaiter(this, void 0, void 0, function* () {
        const s1 = toolbox_1.NewTestingServer({});
        const fifo = s1._server.getDocumentsFIFO();
        const ops = [];
        for (let i = 0; i < 10; i++) {
            ops.push(querablep(fifo.pushFIFOPromise('op_' + i, () => __awaiter(this, void 0, void 0, function* () {
                // Wait 100ms
                yield new Promise(res => setTimeout(res, 15));
            }))));
        }
        fifo.remainingTasksCount().should.equal(10);
        while (fifo.remainingTasksCount() >= 9) {
            // Wait 1ms until two tasks have been taken
            yield new Promise(res => setTimeout(res, 5));
        }
        yield fifo.closeFIFO();
        yield ops[0];
        yield ops[1];
        fifo.remainingTasksCount().should.equal(8);
        ops[0].isFulfilled().should.equal(true);
        ops[1].isFulfilled().should.equal(true);
        for (let i = 2; i < 10; i++) {
            ops[i].isFulfilled().should.equal(false);
        }
    }));
});
//# sourceMappingURL=server-shutdown.js.map